program oosimpleshell;

(**
 * program oosimpleshell;
 *
 * Description: Demonstrates an OO approach of how a command shell works
 *)

uses Classes,Process;

var
  cmdline : string;
  cmd     : string;
  f       : TForker;
{$IFDEF DEBUG}
  ret     : TForkerWhichProc;
{$ENDIF}

  
  procedure ParseArgs(commandline : string; var cmd : string;
                      strlst : TStrings);

  var
    tmp    : string;
    i      : integer;

  begin
    // start with an empty parameter list
    strlst.Clear;

    tmp := commandline;
    i   := Pos(' ',tmp);
    while (i > 0) do
    begin
      // found an argument
      // extract the string from 1 to i-1
      strlst.Add(  Copy(tmp,1,(i-1)) );

      tmp := Copy(tmp,i+1,length(tmp));
      i   := Pos(' ',tmp);
    end;

    if (tmp <> '') then
    begin
      // found an argument
      // extract the string from 1 to len
      strlst.Add( Copy(tmp,1,length(tmp)) );
    end;

    // now get the command from the first argument
    cmd := strlst.Strings[0];

    // and delete the first parameter
    strlst.Delete(0);

{$IFDEF DEBUG}
    writeln('The length of args is ',strlst.Count);
    writeln('Parsed, cmd is ',cmd);
    for i := 0 to strlst.Count-1 do
    begin
       writeln('strlst[',i,'] is ',strlst.Strings[i]);
    end;
    writeln('----------------');
{$ENDIF}
  end;

begin
  // create the forker object
  f := TForker.Create;
  f.Exec := TExecuter.Create;
{$IFDEF DEBUG}
  f.Debug := true;
  f.Exec.Debug := true;
{$ENDIF}
  f.WaitForChild := true;

  while true do
  begin
    write('[ooss]$ ');
    readln(cmdline);
    if (cmdline = '') then
       break;

    // search for arguments in the string
    ParseArgs(cmdline, cmd, f.Exec.Parameters);

    f.Exec.ProcessName := cmd;
    {$IFDEF DEBUG} ret := {$ENDIF} f.DoFork;
{$IFDEF DEBUG}
    writeln('Done.. I am returned from ',ord(ret),' 0 parent, 1 child');
{$ENDIF}

  end;
end.
